#!/usr/bin/perl -- #-*- perl -*- for emacs

use strict;
use Socket;
use Tk;

if (scalar(@ARGV) != 3) {
    print "usage: winamp_host_ip winamp_host_port, password\n";
    print "requires winampRC plugin to be installed on the winamp host\n";
    exit(0);
}

my($iaddr, $hisiaddr, $hispaddr, $proto, $paddr, $top, $map,
   $canvas, $cimage);

$0 = "waRC - winamp remote control, perl/Tk client";

# initialize communications
$iaddr = gethostbyname("localhost");
$proto = getprotobyname('udp');
$paddr = sockaddr_in(0, $iaddr); # 0 means let kernel pick

socket(SOCKET, PF_INET, SOCK_DGRAM, $proto)   || die "socket: $!";
#bind(SOCKET, $paddr)                          || die "bind: $!";

$| = 1;

$hisiaddr = inet_aton($ARGV[0]);
$hispaddr = sockaddr_in($ARGV[1], $hisiaddr);
#done with initialize

# build Tk interface
$top = MainWindow->new;
$canvas = $top->Canvas(-height => 12, -width => 110, -background => 'black');


$map = $top->Pixmap('bob', -file => "warc.xpm");
$cimage = $canvas->createImage(55,5, -image => $map);
$canvas->pack(-side => "top");
$canvas->addtag('bob', "all");
$canvas->bind('bob', "<ButtonPress>" => [\&send_command, Ev("%x"), Ev("%y")]);

MainLoop;

sub send_command {
    my ($this, $x, $y) = @_;

    my $pass = "$ARGV[2]\n";
    my @cmds = qw(40044 40045 40046 40047 40048);
    my @text = qw(prev play pause stop next);

# these commands aren't used cause I was too lazy to make the pixmap
    my @unused = qw(40058 40059 40060 40061);
    my @untext = qw(vol+ vol- ffor revs);

    my $cmd = $x / 22;
    print "sending $text[$cmd]\n";
    send(SOCKET, "${pass}$cmds[$cmd]", 0, $hispaddr);
}
